local function voice()
require "import"
import "android.widget.*"
import "java.io.BufferedWriter"
import "java.io.FileWriter"
import "java.io.IOException"
import "android.content.Context"
import "android.content.Intent"
import "java.util.Locale"
import "android.speech.SpeechRecognizer"
import "android.speech.RecognitionListener"
import "android.speech.RecognizerIntent"
local substitutionTable = {   
    ["chino"] = "Jieshuo"   
}   

function hasInternetConnection()   
    local connectivityManager = this.getSystemService(Context.CONNECTIVITY_SERVICE)   
    local networkInfo = connectivityManager.getActiveNetworkInfo()   
    return networkInfo ~= nil and networkInfo.isConnected()   
end   

function kill()   
    speechRecognizer.destroy()   
    speechRecognizer = nil   
    return true   
end   

function startListening()   
    if not hasInternetConnection() then   
        service.asyncSpeak("இணைய இணைப்பு இல்லை.இணைய இணைப்பை சரி பார்த்த பிறகு  மீண்டும் முயலவும்.")   
        return false   
    end   

    local verbalizationDetected = false   

    speechRecognizer = SpeechRecognizer.createSpeechRecognizer(this)   

    speechListener = RecognitionListener{   
        onResults = function(results)   
            data = results.getParcelableArrayList(SpeechRecognizer.RESULTS_RECOGNITION)   
            if data ~= nil and data.size() > 0 then   
                verbalizationDetected = true   
                local recognizedText = data.get(0)   
                local node = service.getEditText()   
                local editText = service.getText(node)   

                if editText and string.len(editText) > 0 then   
                    recognizedText = " " .. recognizedText   
                end   

                recognizedText = string.gsub(recognizedText, "(%s?ஸ்டார்)(%s?)([%p]*)$", "%2*%3")   
                recognizedText = string.gsub(recognizedText, "(%s?)சிம்பல்(%s?)([%p]*)$", "%2#%3")   

                service.insertText(node, recognizedText)   
                service.speak(recognizedText)   
            end   

            if not verbalizationDetected then   
                kill()   
                return false   
            end   
        end,   
        onError = function()   
            kill()   
            return false   
        end   
    }   

    recognizerIntent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)   
    recognizerIntent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)   
    recognizerIntent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "ta_IN")   
    recognizerIntent.putExtra(RecognizerIntent.EXTRA_CALLING_PACKAGE, this.getPackageName())   

    speechRecognizer.startListening(recognizerIntent)   
    speechRecognizer.setRecognitionListener(speechListener)   

    return true   
end   
startListening()   
return true
end
return voice